
/* ----------------------------------------------------------------------
   A. Veneziani - classe che implementa alcune operazioni
                  sulle frazioni viste come oggetto

                  Scritto in C++ Builder 6
   ---------------------------------------------------------------------- */               

#include <iostream>
#include "stdlib.h"

using namespace std;

// classe che implmenta una frazione ed alcune operazioni su essa
class Frazione {

    private:
    int numer;
    int denom;

    public:

    int confronta(Frazione f)
    {
        float vf1, vf2;

        vf1 = numer / denom;
        vf2 = f.numer / f.denom;

        if (vf1 == vf2)  return(0);
        if (vf1 > vf2)
           return(1);
        else
           return(-1);
    }

    void definisci(int n, int d)
    {
        numer = n;
        denom = d;
    }

    void assegna(Frazione f)
    {
       numer = f.numer;
       denom = f.denom;
    }    

    bool e_intero()
    {
         Frazione f;

         f.assegna((*this));
         f.riduci();

         if (f.denom == 1)
            return(true);
         else
            return(false);   
    }

    
    void riduci()
    {
        int div;
        bool diviso;

        for (div = 2; div <= min(numer, denom); div++)
        do {
            diviso = false;        
            if (((numer % div) == 0) && ((denom % div) == 0))
            {
                numer = numer / div;
                denom = denom / div;
                diviso = true;
            }
       } while(diviso);     
    }

    void stampa_fraz()
    {
        cout << numer << " / " << denom << endl; 
    }

    Frazione somma(Frazione f)
    {
        Frazione fr;

        fr.numer = numer * f.denom + f.numer * denom;
        fr.denom = denom * f.denom;

        fr.riduci();

        return(fr);
    }
};

int main()
{
     Frazione f, f2, fr;

     f.definisci(36,80);
     f.riduci();

     f.stampa_fraz();

     f2.definisci(10,5);
     cout << f.confronta(f2);

     fr = f.somma(f2);
     fr.stampa_fraz();

     cout << f2.e_intero();

     cin.get();

     return 0;
}

